Elite - 精锐编译器
==================

Elite是一款脚本化驱动的编译器，一般的编程语言，语法是固定的，只能使用有限的表达方式，而Elite的语法并非固定，而是由脚本配置而成的，如果需要，随时都可以自由更改。

这个特点，使得Elite非常容易自由开发，成为一款领域专业语言（DSL），在自由配置后，方便地表达专业的相关内容。

## 其他语言文档

- [English Documents](../index.html)
- [中文文档](#)

## 下载、使用和贡献代码

Elite是一款开源项目，任何人都可以免费使用，修改和发布该项目代码，遵循MIT协议。

- 下载：<https://github.com/elite-lang/Elite>
- [编译安装指南](md-install.html)
- [贡献本项目](md-develop.html)

## Elite语言正在解决哪方面的问题

在专用编程中，有很多东西很难用通用编程语言去描述，人们为了在通用语言中描述这些不好描述的内容，创建了配置文件。然而一旦不好描述的部分占了主体，那么势必造成配置过于繁琐，使用过于复杂等问题。针对这种情况，一般会开发领域专用语言，但问题依旧存在。领域专用语言，难以和通用语言例如C、Java，进行通信，较难使用可靠的开发库。

Elite是一款可自定语法的编程语言，通过自行配置语法，能够方便的定制需要的语言形式，从而将自己包装成一款领域专用语言，包装后的语言拥有和通用语言一样的编程能力，但又多了自定义的语法形式，避免了过度使用配置文档的问题。

## 什么项目适合用Elite开发

1. 专业领域的程序库
2. 具有复杂难以理解配置项的软件包
3. 拥有复杂抽象模型的软件框架
4. 快速开发编译器语法原型
5. 拥有特定语法的交互式控制台程序


## 加入我们

目前，项目还处于开发初期，非常欢迎热爱开源的朋友们参加此项目，这是一个中等规模的C++项目，加入我们的团队，不但能够促进该项目更快的发展，更能带给您不一样的思路和体验。

希望和我们交流非常容易，可以选择发邮件或在github上直接和我们联系，都可以。

- github：<https://github.com/elite-lang/Elite>
- 邮箱：<mailto:sunxfancy@gmail.com>
- gitter：[参与讨论] (https://gitter.im/elite-lang/Elite?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)

## 开源协议

MIT协议，允许任何人基于该项目开发其他项目，无论是开源的还是商业的，仅仅需要您在使用时，附带我们的版权声明即可。

## 关于本文档

本文档分为三部分，其一是用户帮助文档，其二是开发者文档，最后还包括全部代码的注释文档。本文档也属于开源项目的一部分，欢迎大家帮助我们完善和改进本文档。本文档使用Markdown格式编写，使用doxygen工具生成。

关于文档的构建与使用：[文件构建参考](md-doc.html)
